#!/usr/bin/python3

from script_utils import *

'''
(1) n <= 5
(2) Второй граф полный
(3) В первом графе две компоненты связности.
(4) В первом графе степень каждой вершины хотя бы 1.
(5) Второй граф звезда
(6) Второй граф дерево
(7) В обоих графах есть ребро (1, 2)
(8) n <= 3000
(9) Второй граф бамбук
(10) Фулл
'''

groupsHandler = GroupsHandler()

@groupsHandler.registerGroup(group=1, score=9)
def group1():
    generate_all_graphs(3)
    generate_all_graphs(4)
    generate_all_graphs(5, maxIterations=5)
    add_script(gmode='all_stars', n=5)

    add_script(gmode='independent', n=5, tests=1, first_mode='many_cliques', cliques=2, second_mode='tree')
    add_script(gmode='complete_xor', n=5, first_mode='random', edges_frac=0)
    add_script(gmode='independent', n=5, tests=1, first_mode="fixed_forest", comps=2, second_mode='tree')
    add_script(gmode='no_common_edges', n=5, tests=1, second_mode='tree', edges_frac=0.5)


@groupsHandler.registerGroup(group=2, score=7)
def group2():
    generate_all_graphs(3)
    generate_all_graphs(4)
    generate_all_graphs(5)
    generate_all_graphs(6, maxIterations=3)

    add_script(gmode='complete_xor', n=77, first_mode='random', edges_frac=0)
    add_script(gmode='independent', n=77, tests=1, first_mode='many_cliques', cliques=2, second_mode='complete')
    add_script(gmode='independent', n=77, tests=1, first_mode='many_cliques', cliques=5, second_mode='complete')
    add_script(gmode='independent', n=77, tests=1, first_mode='clique', second_mode='complete')
    add_script(gmode='independent', n=77, tests=1, first_mode='random', edges_frac=0.1, second_mode='complete')
    add_script(gmode='independent', n=77, tests=1, first_mode='fixed_forest', comps=5, second_mode='complete')
    add_script(gmode='independent', n=77, tests=1, first_mode='random_comps', comps=5, extra_edges_frac=0.3, second_mode='complete')


@groupsHandler.registerGroup(group=3, score=10)
def group3():
    generate_all_graphs(3)
    generate_all_graphs(4)
    generate_all_graphs(5, maxIterations=2)
    add_script(gmode='all_stars', n=5)

    add_script(gmode='complete_xor', n=78, first_mode='clique')
    add_script(gmode='complete_xor', n=7, first_mode='clique')
    add_script(gmode='complete_xor', n=77, first_mode='many_cliques', cliques=2)

    add_script(gmode='independent', n=77, tests=1, first_mode='many_cliques', cliques=2, second_mode='star')
    add_script(gmode='independent', n=77, tests=1, first_mode='many_cliques', cliques=2, second_mode='tree')
    add_script(gmode='independent', n=77, tests=1, first_mode='many_cliques', cliques=2, second_mode='extra_tree', extra_frac=0.1)
    add_script(gmode='independent', tests=5, first_mode="fixed_forest", comps=2, second_mode='tree')
    add_script(gmode='independent', tests=1, first_mode="fixed_forest", comps=2, second_mode='star')
    add_script(gmode='independent', n=2300, tests=1, first_mode="random_comps", comps=2, extra_edges_frac=0.3, second_mode='extra_tree', extra_frac=0.2)


@groupsHandler.registerGroup(group=4, score=11)
def group4():
    generate_all_graphs(3)
    generate_all_graphs(4)
    generate_all_graphs(5, maxIterations=1)
    add_script(gmode='all_stars', n=5)

    add_script(gmode='complete_xor', n=77, first_mode='random', edges_frac=0.7)
    add_script(gmode='complete_xor', n=77, first_mode='many_cliques', cliques=5)

    add_script(gmode='independent', tests=40, first_mode='random', edges_frac=0.4, second_mode='star')
    add_script(gmode='independent', tests=27, first_mode='random', edges_frac=0.4, second_mode='tree')
    add_script(gmode='independent', tests=1, first_mode='fixed_forest', comps_frac=0.88, second_mode='tree')
    add_script(gmode='independent', tests=1, n=2500, first_mode="random_comps", comps=228, extra_edges_frac=0.3, second_mode='extra_tree', extra_frac=0.18)
    add_script(gmode='independent', tests=1, n=80, first_mode="many_cliques", cliques=9, second_mode='tree')
    add_script(gmode='independent', tests=1, n=2800, first_mode="pairing", second_mode='extra_tree', extra_frac=0.07)


@groupsHandler.registerGroup(group=5, score=15)
def group5():
    generate_all_graphs(3)
    generate_all_graphs(4)
    add_script(gmode='all_stars', n=5)

    add_script(gmode='independent', tests=40, first_mode='random', edges_frac=0.4, second_mode='star')
    add_script(gmode='independent', tests=30, first_mode='forest', edges_frac=0.4, second_mode='star')
    add_script(gmode='independent', tests=5, first_mode="fixed_forest", comps_frac=0.8, second_mode='star')
    add_script(gmode='independent', tests=1, n=2600, first_mode="random_comps", comps=228, extra_edges_frac=0.3, second_mode='star')
    add_script(gmode='independent', tests=1, n=83, first_mode='many_cliques', cliques=4, second_mode='star')

    add_script(gmode='no_common_edges', n='3e3', tests=10, second_mode='star', edges_frac=0.17)


@groupsHandler.registerGroup(group=6, depends=[5], score=8)
def group6():
    generate_all_graphs(3)
    generate_all_graphs(4)
    generate_all_graphs(5, maxIterations=1)
    add_script(gmode='all_stars', n=5)

    add_script(gmode='complete_xor', n=78, first_mode='clique')
    add_script(gmode='independent', tests=20, first_mode='random', edges_frac=0.2, second_mode='tree')
    add_script(gmode='independent', tests=20, first_mode='forest', edges_frac=0.15, second_mode='tree')
    add_script(gmode='no_common_edges', n='3e3', tests=20, second_mode='tree', edges_frac=0.1)

    add_script(gmode='independent', n=77, tests=1, first_mode='many_cliques', cliques=8, second_mode='star')
    add_script(gmode='independent', n=77, tests=1, first_mode='many_cliques', cliques=10, second_mode='tree')
    add_script(gmode='independent', tests=5, first_mode="fixed_forest", comps_frac=0.8, second_mode='tree')
    add_script(gmode='independent', tests=1, n=2700, first_mode="random_comps", comps=179, extra_edges_frac=0.2, second_mode='tree')


@groupsHandler.registerGroup(group=7, score=12)
def group7():
    generate_all_graphs(3)
    generate_all_graphs(4)
    add_script(gmode='all_stars', n=5)

    add_script(gmode='complete_xor', n=77, first_mode='fixed_forest', comps_frac=0.8)

    add_script(gmode='independent', tests=38, first_mode='random', edges_frac=0.4, second_mode='star')
    add_script(gmode='independent', tests=28, first_mode='random', edges_frac=0.4, second_mode='tree')
    add_script(gmode='independent', tests=1, first_mode='fixed_forest', comps_frac=0.87, second_mode='tree')
    add_script(gmode='independent', tests=1, n=2500, first_mode="random_comps", comps=239, extra_edges_frac=0.3, second_mode='extra_tree', extra_frac=0.18)
    add_script(gmode='independent', tests=1, n=80, first_mode="many_cliques", cliques=10, second_mode='tree')
    add_script(gmode='independent', tests=1, first_mode="pairing", second_mode='tree')


@groupsHandler.registerGroup(group=8, depends=list(range(0, 8)), score=6)
def group8():
    generate_all_graphs(3)
    generate_all_graphs(4)
    generate_all_graphs(5, maxIterations=2)
    add_script(gmode='all_stars', n=5)

    add_script(gmode='complete_xor', n=77, first_mode='fixed_forest', comps_frac=0.7)
    add_script(gmode='complete_xor', n=77, first_mode='random_comps', comps=9, extra_edges_frac=0.4)

    add_script(gmode='independent', n=1900, tests=1, first_mode='random_comps', comps=42, extra_edges_frac=0.6, second_mode='tree')
    add_script(gmode='independent', n=1900, tests=1, first_mode='random_comps', comps=51, extra_edges_frac=0.5, second_mode='extra_tree', extra_frac=0.35)
    add_script(gmode='independent', n=2800, tests=1, first_mode='fixed_forest', comps_frac=0.1, second_mode='extra_tree', extra_frac=0.05)
    add_script(gmode='independent', n=78, tests=1, first_mode='many_cliques', cliques=5, second_mode='extra_tree', extra_frac=0.02)

    add_script(gmode='no_common_edges', n='3e3', tests=10, second_mode='tree', edges_frac=0.17)


@groupsHandler.registerGroup(group=9, score=8)
def group9():
    generate_all_graphs(3)
    generate_all_graphs(4)
    generate_all_graphs(5)
    add_script(gmode='all_bamboos', n=6)

    add_script(gmode='independent', tests=40, first_mode='random', edges_frac=0.4, second_mode='bamboo')
    add_script(gmode='independent', tests=30, first_mode='forest', edges_frac=0.4, second_mode='bamboo')
    add_script(gmode='independent', tests=1, first_mode='forest', edges_frac=0.1, second_mode='bamboo')
    add_script(gmode='independent', tests=5, first_mode="fixed_forest", comps_frac=0.8, second_mode='bamboo')
    add_script(gmode='independent', tests=1, n='2.1e5', first_mode="random_comps", comps=228, extra_edges_frac=0.3, second_mode='bamboo')
    add_script(gmode='independent', tests=1, n=500, first_mode='many_cliques', cliques=4, second_mode='bamboo')

    add_script(gmode='no_common_edges', n='3e5', tests=10, second_mode='bamboo', edges_frac=0.17)


@groupsHandler.registerGroup(group=10, depends=list(range(0, 10)), score=14)
def group10():
    generate_all_graphs(3)
    generate_all_graphs(4)
    generate_all_graphs(5)
    generate_all_graphs(6, maxIterations=2)

    add_script(gmode='all_trees', n=6, first_mode='random', edges_frac=0.4)
    add_script(gmode='all_trees', n=7, first_mode='random', edges_frac=0.4)

    add_script(gmode='independent', tests=1, first_mode='forest', edges_frac=0.4, second_mode='bamboo')
    add_script(gmode='independent', tests=1, first_mode='random', edges_frac=0.9, second_mode='bamboo')

    add_script(gmode='independent', tests=1, first_mode='random', edges_frac=0.4, second_mode='star')
    add_script(gmode='independent', tests=1, first_mode='forest', edges_frac=0.8, second_mode='star')
    add_script(gmode='independent', tests=5, first_mode="fixed_forest", comps_frac=0.8, second_mode='tree')
    add_script(gmode='independent', tests=1, first_mode="fixed_forest", comps_frac=0.8, second_mode='tree')

    add_script(gmode='independent', n=180000, tests=1, first_mode='random_comps', comps=100, extra_edges_frac=0.6, second_mode='tree')
    add_script(gmode='independent', n=180000, tests=1, first_mode='random_comps', comps=1337, extra_edges_frac=0.5, second_mode='extra_tree', extra_frac=0.35)

    add_script(gmode='complete_xor', n=776, first_mode='clique')
    add_script(gmode='complete_xor', n=775, first_mode='random', edges_frac=0)
    add_script(gmode='complete_xor', n=775, first_mode='many_cliques', cliques=2)
    add_script(gmode='complete_xor', n=775, first_mode='many_cliques', cliques=337)
    add_script(gmode='complete_xor', n=775, first_mode='fixed_forest', comps_frac=0.8)
    add_script(gmode='complete_xor', n=775, first_mode='random_comps', comps=34, extra_edges_frac=0.6)

    add_script(gmode='no_common_edges', n='3e5', tests=50, second_mode='tree', edges_frac=0.1)
    add_script(gmode='independent', n='3e5', tests=1, first_mode='random_comps', comps='1e5', extra_edges_frac=0.0, second_mode='tree')


if __name__ == '__main__':
    groupsHandler.execute()
