#include "bits/stdc++.h"

using namespace std;

class dsu {
public:
    vector<int> p;
    int n;
    int comp;
    dsu(int n) : n(n) {
        p.resize(n);
        comp = n;
        iota(p.begin(), p.end(), 0);
    }
    void clear() {
        iota(p.begin(), p.end(), 0);
    }
    int get(int x) {
        return (x == p[x] ? x : (p[x] = get(p[x])));
    }
    bool unite(int x, int y) {
        x = get(x);
        y = get(y);
        if (x != y) {
            p[x] = y;
            comp--;
            return true;
        }
        return false;
    }
};

void solve() {
    int n, m1, m2;
    cin >> n >> m1 >> m2;
    vector<vector<int>> g(n), g2(n), g3(n);
    set<pair<int, int>> st, st2;
    vector<int> deg(n);
    dsu G(n), G2(n);
    for (int i = 0; i < m1; i++) {
        int x, y;
        cin >> x >> y;
        x--, y--;
        st.insert({x, y});
        st.insert({y, x});
        G.unite(x, y);
        g[x].push_back(y);
        g[y].push_back(x);
        deg[x]++, deg[y]++;
    }
    for (int i = 0; i < m2; i++) {
        int x, y;
        cin >> x >> y;
        x--, y--;
        st2.insert({x, y});
        st2.insert({y, x});
        g3[x].push_back(y);
        g3[y].push_back(x);
    }
    for (auto [x, y] : st2) {
        if (G2.get(x) == G2.get(y)) {
            continue;
        }
        if (g2[x].size() == n - 2 || g2[y].size() == n - 2) {
            continue;
        }
        g2[x].push_back(y);
        g2[y].push_back(x);
        G2.unite(x, y);
    }
    for (auto [x, y] : st2) {
        if (G2.get(x) == G2.get(y)) {
            continue;
        }
        g2[x].push_back(y);
        g2[y].push_back(x);
        G2.unite(x, y);
    }
    if (G.comp == 1) {
        cout << "Yes\n0\n\n";
        return;
    }
    for (int v = 0; v < n; v++) {
        if (g2[v].size() == n - 1) {
            if (deg[v] != 0) {
                continue;
            }
            for (int u = 0; u < n; u++) {
                if (u == v) {
                    continue;
                }
                int w = -1;
                for (int i = 0; i < n; i++) {
                    if (i != v && i != u) {
                        bool have = st.find({i, u}) != st.end();
                        bool have2 = st2.find({i, u}) != st2.end();
                        if (have == have2) {
                            vector<pair<int, int>> ans;
                            for (int j = 0; j < n; j++) {
                                if (j != v && j != u) {
                                    if (st.find({j, u}) == st.end()) {
                                        ans.push_back({j, u});
                                        G.unite(j, u);
                                    }
                                }
                            }
                            ans.push_back({u, v});
                            G.unite(u, v);
                            assert(G.comp == 1);
                            cout << "Yes\n" << (int) ans.size() << '\n';
                            for (auto [x, y] : ans) {
                                cout << x + 1 << " " << y + 1 << '\n';
                            }
                            return;
                        }
                    }
                }
            }
            if (n >= 4) {
                int u = g2[v][0];
                vector<pair<int, int>> ans;
                for (int j = 0; j < n; j++) {
                    if (j != v && j != u) {
                        if (st.find({j, u}) == st.end()) {
                            ans.push_back({j, u});
                            G.unite(j, u);
                        }
                    }
                }
                if (G.comp != 1) {
                    int X = g2[v][1], Y = g2[v][2];
                    if (st2.find({X, Y}) == st2.end()) {
                        ans.push_back({X, Y});
                        ans.push_back({X, v});
                        G.unite(X, v);
                    }
                }
                assert(G.comp == 1);
                cout << "Yes\n" << (int) ans.size() << '\n';
                for (auto [x, y]: ans) {
                    cout << x + 1 << " " << y + 1 << '\n';
                }
                return;
            }
            cout << "No\n";
            return;
        }
    }
    function<pair<int, int>(int, int)> get = [&] (int v, int pr) {
        pair<int, int> res = {0, v};
        for (auto u : g2[v]) {
            if (u != pr) {
                auto res2 = get(u, v);
                res2.first++;
                res = max(res, res2);
            }
        }
        return res;
    };
    int V = get(0, -1).second;
    auto [d, U] = get(V, -1);
    assert(g2[U].size() == 1);
    int W = g2[U][0];
    vector<pair<int, int>> ans;
    for (int i = 0; i < n; i++) {
        if (i != U && i != W) {
            if (st.find({i, U}) == st.end()) {
                ans.push_back({i, U});
                G.unite(i, U);
            }
        }
    }
    set<int> ban(g2[W].begin(), g2[W].end());
    for (int v = 0; v < n && G.comp != 1; v++) {
        if (v != W && ban.find(v) == ban.end()) {
            ans.push_back({v, W});
            G.unite(v, W);
            assert(G.comp == 1);
        }
    }
    if (G.comp == 1) {
        cout << "Yes\n" << (int) ans.size() << '\n';
        for (auto [x, y] : ans) {
            cout << x + 1 << " " << y + 1 << '\n';
        }
        return;
    }
    cout << "No\n";
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t, g;
    cin >> t >> g;
    while (t--) {
        solve();
    }
}
