#include <bits/stdc++.h>
using namespace std;

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());

struct DSU {
    vector<int> par;
    int components;

    DSU(int n) : par(n), components(n) {
        iota(par.begin(), par.end(), 0);
    }
    
    int root(int v) {
        return par[v] == v ? v : (par[v] = root(par[v]));
    }

    bool unite(int v, int u) {
        v = root(v);
        u = root(u);
        if (v == u) {
            return false;
        }
        components--;
        par[u] = v;
        return true;
    }
};

void solve() {
    int n, m1, m2;
    cin >> n >> m1 >> m2;

    DSU dsu(n);
    for (int i = 0; i < m1; i++) {
        int v, u;
        cin >> v >> u;
        dsu.unite(v - 1, u - 1);
    }

    DSU dsu2(n);
    set<pair<int, int>> edges;
    for (int i = 0; i < m2; i++) {
        int v, u;
        cin >> v >> u;
        v--, u--;
        if (dsu2.unite(v, u)) {
            edges.insert(minmax(v, u));
        }
    }
    vector<pair<int, int>> ops;

    auto make_op = [&](int v, int u) {
        if (edges.count(minmax(v, u))) {
            edges.erase(minmax(v, u));
        } else {
            edges.insert(minmax(v, u));
        }
        ops.emplace_back(v, u);
    };

    auto output = [&]() {
        cout << "Yes\n";
        cout << ops.size() << '\n';
        for (auto [v, u] : ops) {
            cout << v + 1 << ' ' << u + 1 << '\n';
        }
    };

    vector<int> order(n);
    iota(order.begin(), order.end(), 0);
    for (int its = 0; its < 40 && dsu.components != 1; its++) {
        shuffle(order.begin(), order.end(), rng);
        for (int i = 0; i + 1 < n; i++) {
            int v = order[i];
            int u = order[i + 1];
            if (dsu.root(v) == dsu.root(u)) {
                continue;
            }
            if (!edges.count(minmax(v, u))) {
                dsu.unite(v, u);
                make_op(v, u);
            }
        }
    }

    if (dsu.components == 1) {
        output();
    } else {
        cout << "No\n";
    }
}

int main() {
    cin.tie(nullptr)->sync_with_stdio(false);
    int tests, group;
    cin >> tests >> group;
    while (tests--) {
        solve();
    }
}
